#!/bin/bash
###################################################################################
##                  Datensicherung auf Online-Festplatten                        ##
################################################################################### 
# Dieses Skript dient dazu, auf einfache Art und Weise persönliche Daten          #
# mit Hilfe des WebDAV-Protokolls zu speichern. Für den reibungslosen Ablauf      #
# werden lediglich das Konsolenprogramm "cadaver" aus den Quellen der             #
# jeweiligen Distribution und das Java-Programm "Mindcrypt" benötigt.             #
# Letzeres kann von der Seite http://mindcrypt.de/ heruntergeladen werden und     #
# erfordert eine Java-Laufzeitumgebung.                                           #
# Des Weiteren sollten die Pakete "kdialog" und "xdg" installiert sein.           #
#                                                                                 #
# Als Vorbereitung müssen nur noch folgende Dateien erstellt werden:              #
#                                                                                 #
#           1. Erstellen der Datei .netrc für den Autologin:                      #
#                                                                                 #
#            z.B.:                                                                #
# machine webdav.mediencenter.t-online.de  login <Login Name> password <Passwort> #               
# machine webdav.mydrive.ch                login <Login Name> password <Passwort> #
# machine <Name>.webdav.hidrive.strato.com login <Login Name> password <Passwort> #
# machine webdav.smartdrive.web.de	   login <Login Name> password <Passwort> #
# machine <Nummer>.webdav.cloudsafe.com	   login <E-Mail>     password <Vorgabe>  #
# machine storage.driveonweb.de		   login <E-Mail>     password <Passwort> #
# machine at.folio.fabasoft.com            login <E-Mail>     password <Passwort> #
# machine www.box.net                      login <E-Mail>     password <Passwort> #
# machine dav.humyo.com                    login <E-Mail>     password <Passwort> #
# machine dav.idrivesync.com               login <E-Mail>     password <Passwort> #
#                                                                                 #
#           2. Erstellen der Datei .cadaverrc_gesamt für die Serverauswahl:       #
#                                                                                 #
#            z.B.:                                                                #
#           A https://www.box.net/dav/Sicherung                                   #
#           B https://<Nummer>.webdav.cloudsafe.com/Sicherung                     #    
#	    C https://storage.driveonweb.de/probdav/Sicherung                     #
#           D https://at.folio.fabasoft.com/folio/webdav/Sicherung                #
#           E https://webdav.mydrive.ch/Sicherung                                 #
#           F https://<Login Name>.webdav.hidrive.strato.com/users/<Login Name>   #
#           G https://webdav.mediencenter.t-online.de/Sicherung                   #
#           H https://webdav.smartdrive.web.de/Sicherung                          #
#           I https://dav.humyo.com/Sicherung                                     #
#           J https://dav.idrivesync.com/Sicherung                                #
#                                                                                 #
# Bitte beachten:  Für die .netrc wählt man                                       #
# aus Gründen der Sicherheit als Zugriffsberechtigung " chmod 600 .netrc "        #
# Beide Dateien, sowie die .MindcryptApp.jar werden direkt unter " ~/ " platziert.#
#                                                                                 #
# In den Zeile 166 und 220 dieses Skriptes werden die erstellten Protokoll-       #
# dateien in den vorher angelegten Ordner ~/Datensicherung/Protokolle/kopiert.    #
# Für ein ordnungsgemäßes Arbeiten sollten beide Ordner vor der ersten Nutzung    # 
# angelegt werden! Selbstverständlich können Name und Speicherort variieren,      #
# allerdings muss dann eine Anpassung im Skript vorgenommen werden.               #
#                                                                                 #         
# Wird dieses Skript zum ersten Mal angewandt, so sollte darauf geachtet          #
# werden, dass beim Öffnen von "Mindcrypt" sowohl bei der Option                  #
# "Verschlüsseln", als auch unter "Entschlüsseln" immer in der Zeile              #
# " Zielverzeichnis " folgende Pfadangabe eingetragen ist:                        #
# " /home/<Name>/WEBDAV/tmp   ".                                                  #
# Diese Pfadangabe wird künftig in der Datei " .mindcrypt.cfg " gespeichert,      #
# die sich ebenfalls direkt im eigenen Home-Verzeichnis befindet.                 #
#                                                                                 #
# ZUR BEACHTUNG: Es wird keine Haftung für Schäden jeglicher Form übernommen,     #
#                welche durch die Nutzung des Skriptes entstehen!                 #
#                                                                                 #
#                                                                                 #
#                                                   Autor: D.Schmidt, Juni 2012   #
###################################################################################

function menu1 {

        cd ~/
        mkdir WEBDAV
	DATENSUCHE="$HOME/WEBDAV/suche" # Inhalt der Protokolldatei durchsuchen; kein Ergebnis oder bei Abbruch Ausgabe else-Anweisung
        SUCHBEGRIFF=$(kdialog --title "Protokolldateien durchsuchen" --inputbox "Suchbegriff eingeben:") 
        find -name *Protokoll* -type f -exec grep -i $SUCHBEGRIFF --exclude=$DATENSUCHE /dev/null {} \; 2> /dev/null | tee $DATENSUCHE | grep -i $SUCHBEGRIFF
        if test -s $DATENSUCHE ; then 
                kdialog --geometry 1024x400 --textbox $DATENSUCHE ; # Suchergebnisse in Dialogbox anzeigen; bei Abbruch while do -Anweisung
                PROTOKOLLNAME=$(kdialog --title "Protokolldatei öffnen" --inputbox "Protokollnamen eingeben:")
                find ~ -type f -name $PROTOKOLLNAME -exec kdialog --geometry 1024x400 --textbox {} \; # Anzeige Inhalt Protokolldatei
                while test -s $PROTOKOLLNAME
                do exit;
                done

# Änderung des Suchergebnisses
while [ "$?" = 0 ]; 
kdialog --yesno "Suchauswahl ändern?";
do [ "$?" = 1 ] 

         kdialog --geometry 1024x400 --textbox $DATENSUCHE ; 
PROTOKOLLNAME=$(kdialog --title "Protokolldatei öffnen" --inputbox "Protokollnamen eingeben:") 
find ~ -type f -name $PROTOKOLLNAME -exec kdialog --geometry 1024x400 --textbox {} \; 

done

              kdialog --yesno "Übertragung fortsetzen?" 0 0 || exit 1 # Bei Auswahl "Nein" Abbruch
	      cd ~/WEBDAV/ 
	      rm -rf tmp tmp_2 # Löschen der tmporären Unterordner nach manuellem Abbruch der letzten Session
              cd ~/WEBDAV/ # Auslesen der Serverdaten aus der Protokolldatei, Erstellen der .cadaverrc, autonatische Serverwahl
              mkdir tmp
              cd ~/WEBDAV/tmp/
              find ~ -type f -name $PROTOKOLLNAME -exec awk ' NR == 1 ' {} \; > .entfernter_Rechner
              echo lcd $HOME/WEBDAV/tmp/ > .eigener_Rechner
              cat .entfernter_Rechner .eigener_Rechner > .cadaverrc 
              sed -i '1s/^/open /' .cadaverrc
                        mv .cadaverrc ~/
                   rm -rf .entfernter_Rechner .eigener_Rechner  
  
              ONLINE_DATEN=$(find ~ -type f -name $PROTOKOLLNAME -exec awk ' NR == 2 ' {} \;)
                        
                   cadaver -t  << EOF
mget $ONLINE_DATEN
quit
EOF
              kdialog --msgbox "Übertragung beendet."

              # Abtrennen der Option "Datum"; einzelne Segmente zusammenführen und umbenennen; entschlüsseln

              cd ~/WEBDAV/tmp/
              find ./ -maxdepth 1 -type f -name "*" | while read l; do mv -v "$l" "${l: -2}"; done
              cat 0? > *.mc
              rm -rf 0?
              find ~ -type f -name .MindcryptApp.jar -exec java -jar {} \;
        rm *.mc # Entfernen der verschlüsselten Datei; Zusammenstellen der Protokolldatei
              mv * ~/WEBDAV
              cd ~/WEBDAV/
              rm -rf ~/WEBDAV/tmp
              xdg-open "$(kdialog --getopenfilename ~/$USER/WEBDAV/)" # Dialogbox öffnet ~/WEBDAV
        else kdialog --sorry "Keine Daten vorhanden.";
              exit;
        fi
}

function menu2 {

        cd ~/
        mkdir WEBDAV
        cd ~/WEBDAV/ 
        rm -rf tmp tmp_2 # Löschen der tmporären Unterordner nach manuellem Abbruch der letzten Session
        mkdir tmp tmp_2
        cd ~/ ; sed -n '1s/^open //p' .cadaverrc > .Servername # Auslesen des Servers aus der .cadaverrc
        mv .Servername ~/WEBDAV/tmp_2/
        find ~ -type f -name .MindcryptApp.jar -exec java -jar {} \; # ausgewählte Daten verschlüsseln
        cd ~/WEBDAV/tmp/
        split -d --bytes=100m *.mc $(date +'%d%m%Y%H%M%S') # Dateien splitten (>100 mb) und umbenennen
        rm *.mc
        ls | paste -sd ' ' > .Kopfzeile # Erstellen der Kopfzeile für Protokolldatei
        mv .Kopfzeile ~/WEBDAV/tmp_2/
        kdialog --yesno "Übertragung fortsetzen?" 0 0 || exit 1 # Bei Auswahl "Nein" Abbruch

        # Upload auf Online-Festplatte
        cadaver -t  << EOF
mput *
quit
EOF
        kdialog --msgbox "Übertragung beendet."
        # Abtrennen der Option "Datum"; einzelne Segmente zusammenführen und umbenennen; entschlüsseln
        cd ~/WEBDAV/tmp/
        find ./ -maxdepth 1 -type f -name "*" | while read l; do mv -v "$l" "${l: -2}"; done
        cat 0? > *.mc
        rm -rf 0?
        find ~ -type f -name .MindcryptApp.jar -exec java -jar {} \;
        rm *.mc # Entfernen der verschlüsselten Datei; Zusammenstellen der Protokolldatei
        ls -hoAR -g --time-style="+%d.%m.%Y %H:%M Uhr" | sed  's/^[ldscbp-]\([r-][w-][xsStT-]\)\++* *[0-9]\+ //' > +
        mv * ~/WEBDAV/tmp_2/
        cd ~/WEBDAV/tmp_2/
        cat .Servername .Kopfzeile + > Protokoll_$(date +'%d-%m-%Y_%H:%M ')
        find cd ~/WEBDAV/tmp_2/ -name "Protokoll_*" -exec cp {} ~/Datensicherung/Protokolle/ \;
        rm -rf .Servername .Kopfzeile +
        mkdir $(date +'%d-%m-%Y_%H:%M ')
        mv * $(date +'%d-%m-%Y_%H:%M ')
        mv * ~/WEBDAV/
        cd ~/WEBDAV/
        rm -rf tmp tmp_2
        # Löschen der einzelnen Protokollsegmente; Dialogbox öffnet Verzeichnis ~/WEBDAV
        xdg-open "$(kdialog --getopenfilename ~/$USER/WEBDAV/)"
}

function menu3 {

        cd ~/
        mkdir WEBDAV
        cd ~/WEBDAV/
	rm -rf tmp tmp_2 # Löschen der tmporären Unterordner nach manuellem Abbruch der letzten Session
        mkdir tmp tmp_2
        cd ~/ ; sed -n '1s/^open //p' .cadaverrc > .Servername # Auslesen des Servers aus der .cadaverrc
        mv .Servername ~/WEBDAV/tmp_2/
        tar czvf $USER.tar.gz /home/$USER --exclude $USER.tar.gz --exclude="*VirtualBox*" # Home-Verzeichnis komprimieren; verschlüsseln aus ~/WEBDAV/tmp
        mv $USER.tar.gz ~/WEBDAV/tmp/
        find ~ -type f -name .MindcryptApp.jar -exec java -jar {} \;
        cd ~/WEBDAV/tmp/
        rm $USER.tar.gz # Entfernen komprimiertes Home-Verzeichnis; Splitten
        split -d --bytes=100m $USER.tar.mc $(date +'%d%m%Y%H%M%S')
        rm $USER.tar.mc
        ls | paste -sd ' ' > .Kopfzeile # Erstellen der Kopfzeile für Protokolldatei
        mv .Kopfzeile ~/WEBDAV/tmp_2/

        kdialog --yesno "Übertragung fortsetzen?" 0 0 || exit 1 # Bei Auswahl "Nein" Abbruch

	# Upload auf Online-Festplatte
cadaver -t  << EOF
mput *
quit
EOF
        kdialog --msgbox "Übertragung beendet."

        # Abtrennen der Option "Datum"; einzelne Segmente zusammenführen und umbenennen; entschlüsseln

        cd ~/WEBDAV/tmp/
        find ./ -maxdepth 1 -type f -name "*" | while read l; do mv -v "$l" "${l: -2}"; done
        cat 0? > *.mc
        rm -rf 0?
        find ~ -type f -name .MindcryptApp.jar -exec java -jar {} \;
        cd ~/WEBDAV/tmp/
        rm -rf *.mc # Entfernen der verschlüsselten Datei; Dekomprimieren des Home-Verzeichnisses
        tar xfvz $USER.tar.gz
        mv $USER.tar.gz ~/WEBDAV/tmp_2/ # Verschieben des Komprimierten Home-Verzeichnisses; Zusammenstellen der Protokolldatei 
        ls -hoAR -g --time-style="+%d.%m.%Y %H:%M Uhr" | sed  's/^[ldscbp-]\([r-][w-][xsStT-]\)\++* *[0-9]\+ //' > +
        mv + ~/WEBDAV/tmp_2/
        cd ~/WEBDAV/tmp_2/
        cat .Servername .Kopfzeile + > Protokoll_$(date +'%d-%m-%Y_%H:%M ')
        find cd ~/WEBDAV/tmp_2/ -name "Protokoll_*" -exec cp {} ~/Datensicherung/Protokolle/ \;
        rm -rf .Servername .Kopfzeile +  # Entfernen von Protokollsegmenten und dekomprimiertem Home-Verzeichnis; Dialogbox öffnet ~/WEBDAV
        mkdir $(date +'%d-%m-%Y_%H:%M ')
        mv * $(date +'%d-%m-%Y_%H:%M ')
        mv * ~/WEBDAV/
        cd ~/WEBDAV/
        rm -rf tmp tmp_2
        xdg-open "$(kdialog --getopenfilename ~/$USER/WEBDAV/)"
}

function menu4 {

      xdg-open "$(kdialog --getopenfilename ~/$USER)"
}

function menu5 {

      cd ~/
                  mkdir WEBDAV
                  cd ~/WEBDAV/
                  mkdir tmp
                  cd ~/WEBDAV/tmp/
                  konsole -e cadaver
}

function menu6 {

        cd ~/ # Inhalt der Protokolldatei durchsuchen;
        mkdir WEBDAV
        DATENSUCHE="$HOME/WEBDAV/suche_löschen"
        SUCHBEGRIFF=$(kdialog --title "Protokolldateien durchsuchen" --inputbox "Suchbegriff eingeben:") 
        find -name *Protokoll* -type f -exec grep -i $SUCHBEGRIFF --exclude=$DATENSUCHE /dev/null {} \; 2> /dev/null | tee $DATENSUCHE | grep -i $SUCHBEGRIFF
        if test -s $DATENSUCHE; then 
                  kdialog --geometry 1024x400 --textbox $DATENSUCHE ; # Suchergebnisse in Dialogbox anzeigen; bei Abbruch while do -Anweisung
                  PROTOKOLLNAME=$(kdialog --title "Protokolldatei öffnen" --inputbox "Protokollnamen eingeben:")
              find ~ -type f -name $PROTOKOLLNAME -exec kdialog --geometry 1024x400 --textbox {} \; # Anzeige Inhalt Protokolldatei; Kopieren der 16 -stelligen Dateinamen in Zwischanablage
              while test -s $PROTOKOLLNAME
                do exit;
                done

              kdialog --yesno "WARNUNG! \nAusgewählte Daten werden unwiderruflich gelöscht.\nTrotzdem fortfahren?" 0 0 || exit 1 # Bei Auswahl "Nein" Abbruch

      cd ~/WEBDAV/ # Auslesen der Serverdaten aus der Protokolldatei, Erstellen der .cadaverrc, autonatische Serverwahl
              mkdir tmp
              cd ~/WEBDAV/tmp/
              find ~ -type f -name $PROTOKOLLNAME -exec awk ' NR == 1 ' {} \; > .entfernter_Rechner
              echo lcd $HOME/WEBDAV/tmp/ > .eigener_Rechner
              cat .entfernter_Rechner .eigener_Rechner > .cadaverrc 
              sed -i '1s/^/open /' .cadaverrc
                      mv .cadaverrc ~/
                   rm -rf .entfernter_Rechner .eigener_Rechner 

              ONLINE_DATEN=$(find ~ -type f -name $PROTOKOLLNAME -exec awk ' NR == 2 ' {} \;)
                   kdialog --msgbox  # Löschen von Online-Daten und Protokoll
              find ~ -name $PROTOKOLLNAME -exec rm {} \;
              cadaver -t  << EOF
delete $ONLINE_DATEN
quit
EOF
              kdialog --msgbox "Ausgewählte Daten erfolgreich gelöscht.."; rm -rf ~/WEBDAV/tmp
        else  kdialog --sorry "Keine Daten vorhanden."
                         exit;
        fi
}

function menu7 {

       if ! kdialog --yesno 'Der WEBDAV-Ordner wird unwiderruflich gelöscht!\nTrotzdem fortfahren?'; then 
		exit;
		  else
    		cd ~/
	      rm -rf WEBDAV
	fi
       }

function menu8 {

        # Auslesen von .cadaverrc und Serverwechsel

        cd ~/
        mkdir WEBDAV
        cd ~/WEBDAV/
        mkdir tmp

        Suche=$(find ~ -type f -name .cadaver_gesamt -exec awk ' NR > 0 ' {} \;)
Antwort=`kdialog --geometry 550x300+250+200 --menu "Auswahl:" $(echo $Suche;);`;

if [ "$?" = 0 ]; then
if [ "$Antwort" = A ]; then
                find ~ -type f -name .cadaver_gesamt -exec awk ' NR == 1 ' {} \; > ~/WEBDAV/tmp/.enfernter_Rechner
        elif [ "$Antwort" = B ]; then
                find ~ -type f -name .cadaver_gesamt -exec awk ' NR == 2 ' {} \; > ~/WEBDAV/tmp/.enfernter_Rechner
        elif [ "$Antwort" = C ]; then
                find ~ -type f -name .cadaver_gesamt -exec awk ' NR == 3 ' {} \; > ~/WEBDAV/tmp/.enfernter_Rechner
        elif [ "$Antwort" = D ]; then
                find ~ -type f -name .cadaver_gesamt -exec awk ' NR == 4 ' {} \; > ~/WEBDAV/tmp/.enfernter_Rechner
        elif [ "$Antwort" = E ]; then
                find ~ -type f -name .cadaver_gesamt -exec awk ' NR == 5 ' {} \; > ~/WEBDAV/tmp/.enfernter_Rechner
        elif [ "$Antwort" = F ]; then
                find ~ -type f -name .cadaver_gesamt -exec awk ' NR == 6 ' {} \; > ~/WEBDAV/tmp/.enfernter_Rechner
        elif [ "$Antwort" = G ]; then
                find ~ -type f -name .cadaver_gesamt -exec awk ' NR == 7 ' {} \; > ~/WEBDAV/tmp/.enfernter_Rechner
        elif [ "$Antwort" = H ]; then
                find ~ -type f -name .cadaver_gesamt -exec awk ' NR == 8 ' {} \; > ~/WEBDAV/tmp/.enfernter_Rechner
        elif [ "$Antwort" = I ]; then
                find ~ -type f -name .cadaver_gesamt -exec awk ' NR == 9 ' {} \; > ~/WEBDAV/tmp/.enfernter_Rechner
        elif [ "$Antwort" = J ]; then
                find ~ -type f -name .cadaver_gesamt -exec awk ' NR ==10 ' {} \; > ~/WEBDAV/tmp/.enfernter_Rechner
        elif [ "$Antwort" = K ]; then
                find ~ -type f -name .cadaver_gesamt -exec awk ' NR ==11 ' {} \; > ~/WEBDAV/tmp/.enfernter_Rechner
	elif [ "$Antwort" = L ]; then
                find ~ -type f -name .cadaver_gesamt -exec awk ' NR ==12 ' {} \; > ~/WEBDAV/tmp/.enfernter_Rechner

        elif [ "$?" = 2 ]; then
                echo "Abbruch gewählt";
        
        fi;
else
	exit 1;
fi;

        echo lcd $HOME/WEBDAV/tmp/ > ~/WEBDAV/tmp/.eigener_Rechner
        cd ~/WEBDAV/tmp/;
        sed -i 's/[A-Z]/open/' ~/WEBDAV/tmp/.enfernter_Rechner
        cat .enfernter_Rechner .eigener_Rechner > .cadaverrc;
        mv .cadaverrc ~/;
        rm -rf ~/WEBDAV/tmp/.enfernter_Rechner .eigener_Rechner

        cadaver_file=$HOME/.cadaverrc


}

# >>> Auswahl Dialogbox <<<

erg=$(kdialog --geometry 300x200+370+280  --title "Datensicherung" --radiolist "Aktion auswählen :" 1 "Daten suchen und herunterladen" on  2 "Daten sichern" off 3 "Home-Verzeichnis sichern" off  4 "Verzeichnis öffnen" off 5 "Verbindung mit Online-Festplatte" off 6 "Löschen von Online-Daten" off 7 "WEBDAV-Ordner entfernen" off )
case $erg in

# >>> Menüpunkt "Daten suchen und herunterladen <<<

  1) menu1
        ;;


# >>> Menüpunkt "Daten sichern" <<<

  2) menu8; 
     menu2 
        ;;
 
# >>> Menüpunkt "Home-Verzeichnis sichern" <<<
     
  3) menu8;
     menu3
        ;;


# >>> Menüpunkt "Verzeichnis öffnen" <<<

  4) menu4
        ;;

# >>> Menüpunkt "Verbindung mit Online-Festplatte" <<<

  5) menu8;
     menu5
        ;;

# >>> Menüpunkt "Löschen von Online-Daten" <<<

  6) menu6
        ;;

# >>> Menüpunkt "WEBDAV-Ordner entfernen" <<<

  7) menu7
        ;;

# >>> Menüpunkt Zugangsdaten überprüfen <<<

  8) menu8
        ;;

esac

    exit 0